#include "ClientConnect.h"
#include "Record.h"
#include "BookActionClient.h"
#include "Messages.h"
#include "myio.h"
#include "intersection.h"

int ADDBOOK(Book m)
/* geeft het exemplaarnummer weer */
     {
	char a;
	assert(m);
	SendChar(ADDBOOK_RQ);
	SendRecord((Record)m,BOOK_FIELD_COUNT);
	FlushMessage();
	a=RecvChar();
	assert(a==ADDBOOK_RP_OK);
	return RecvInteger();
     }

int DELETEBOOK(Book m)
     {
	assert(m);
	SendChar(DELETEBOOK_RQ);
	SendRecord((Record)m,BOOK_FIELD_COUNT);
	FlushMessage();
	return RecvChar();
     }

int UPDATEBOOK(Book b, Book n)
     {
	assert(b && n);
	SendChar(UPDATEBOOK_RQ);
	SendRecord((Record)b,BOOK_FIELD_COUNT);
	SendRecord((Record)n,BOOK_FIELD_COUNT);
	FlushMessage();
	return RecvChar();
     }

BookSearchResult FINDBOOKS(Book b)
{
   int aantal;
   BookSearchResult result;
   assert(b);
   SendChar(FINDBOOKS_RQ);
   SendRecord((Record)b,BOOK_FIELD_COUNT);
   FlushMessage();
   if (RecvChar()!=FINDBOOKS_RP_OK)
     {
	result.result=NULL;
	result.result=0;
	return result;
     }
   /* dan nu eens converteren naar een waardevol lijstje */
   aantal=RecvInteger();
   assert(aantal>=0);
   if (!aantal) result.result=NULL;
   else result.result=(Book*)zmalloc(sizeof(Book)*aantal);
   result.aantal=aantal;
   while(aantal>0)
     {
	aantal--;
	result.result[aantal]=RecvRecord(BOOK_FIELD_COUNT);
     }
   return result;
}

typedef struct sBookSubdialog {
   inputandstatic names,isbns,auteurs,uitgevers,versies,rubrieks,positions;
} BookSubdialog;

BookSubdialog CreateBookSubdialog(Book b)
     {
	BookSubdialog bs;
	bs.names=MakeInputAndStatic(2,2,50,"Name ",&b->Name);
	bs.auteurs=MakeInputAndStatic(2,3,50,"Auteur(s) ",&b->Auteur);
	bs.uitgevers=MakeInputAndStatic(2,4,50,"Uitgever ",&b->Uitgever);
	bs.versies=MakeInputAndStatic(2,5,10,"Exemplaar ",&b->Versie);
	bs.isbns=MakeInputAndStatic(42,5,20,"ISBN ",&b->ISBN);
	bs.rubrieks=MakeInputAndStatic(2,6,5,"Rubriek ",&b->Rubriek);
	bs.positions=MakeInputAndStatic(42,6,20,"Position ",&b->Position);
	return bs;
     }

static void CurrentChanged(Book r,BookSubdialog*bs)
     {
	assert(bs && r);
	PasteInputString(bs->names.i,r->Name);
	PasteInputString(bs->auteurs.i,r->Auteur);
	PasteInputString(bs->uitgevers.i,r->Uitgever);
	PasteInputString(bs->versies.i,r->Versie);
	PasteInputString(bs->isbns.i,r->ISBN);
	PasteInputString(bs->rubrieks.i,r->Rubriek);
	PasteInputString(bs->positions.i,r->Position);
     }

void Key(int c, Book r,dialog d)
     {
	if (c=='e' || c=='E')
	  {
	     EditBook(r);
	     RedrawDialog(d);
	  }
	if (c=='d' || c=='D')
	  {
	     DeleteBook(r);
 	     RedrawDialog(d);
	  }
     }

Book SelectBookMenu(char* Title)
     {
	int answer;
	Book result=NULL;
	Book m;
	Book bookheader;
	BookSubdialog bs;
	listbox lb;
	dialog d;
	bookheader=(Book)AllocateRecord(BOOK_FIELD_COUNT);
	bookheader->Key=" nr ";
	bookheader->ISBN="     ISBN      ";
	bookheader->Name="                     Name                      ";
	bookheader->Auteur="          Auteur(s)      ";
	bookheader->Uitgever="          Uitgever         ";
	bookheader->Versie="  Exemplaar  ";
	bookheader->Rubriek="  Type  ";
	bookheader->Position="     Position    ";
	m=(Book)AllocateRecord(BOOK_FIELD_COUNT);
	bs=CreateBookSubdialog(m);
	lb=MakeListBox(2,8,76,15,NULL,8,0,bookheader);
	SetListBoxCurrentChangedCallback(lb,CurrentChanged,&bs);
	d=MakeDialog(15,(!Title ? "Search books" : Title),
		     bs.names.s,bs.names.i,bs.auteurs.s,bs.auteurs.i,
		     bs.uitgevers.s,bs.uitgevers.i,bs.versies.s,bs.versies.i,
		     bs.isbns.s,bs.isbns.i,bs.rubrieks.s,bs.rubrieks.i,
		     bs.positions.s,bs.positions.i,lb);
	if (!Title) SetListBoxKeyCallback(lb,Key,d);
	while(1)
	  {
	     if ((answer=RunDialog(d))==DIALOG_CANCEL) break;
	       {
		  BookSearchResult sr=FINDBOOKS(m);
		  SetListBoxContents(lb,sr.result,sr.aantal);
		  if (sr.aantal==0)
		    StatusLine("Geen boeken gevonden");
		  else
		    {
		       SetDialogCurrent(d,14); /* direct naar listbox na selectie
						* op verzoek van Sven */
		       if (Title && sr.aantal==1)
			 {
			    result=sr.result[0];
			    break;
			 }
		       else result=NULL;
		    }
	       }
	  }
	FreeRecord((Record)m,BOOK_FIELD_COUNT);
	FreeDialogAndContents(d);
	return result;
     }


/* boek wijzigt als de server het boek gewijzigt heeft */
void EditBook(Book b)
     {
	Book n;
	BookSubdialog bs;
	dialog d;
	n=(Book)AllocateRecord(BOOK_FIELD_COUNT);
	PasteRecord((Record)n,(Record)b,BOOK_FIELD_COUNT);
	bs=CreateBookSubdialog(n);
	while (1)
	  {
	     d=MakeDialog(14,"Edit book",bs.names.s,bs.names.i,bs.auteurs.s,bs.auteurs.i,
			  bs.uitgevers.s,bs.uitgevers.i,bs.versies.s,bs.versies.i,
			  bs.isbns.s,bs.isbns.i,bs.rubrieks.s,bs.rubrieks.i,
			  bs.positions.s,bs.positions.i);
	     if (RunDialog(d)==DIALOG_CANCEL) break;
	     if (UPDATEBOOK(b,n)!=UPDATEBOOK_RP_OK) StatusLine("Failed to update book");
	     else 
	       {
		  PasteRecord((Record)b,(Record)n,BOOK_FIELD_COUNT);
		  StatusLine("Book updated successfully");
		  break;
	       }
	  }
     	FreeRecord((Record)n,BOOK_FIELD_COUNT);
	FreeDialogAndContents(d);
     }

void DeleteBook(Book b)
     {
	keuze k;
	statictext names,auteurs, uitgevers, isbns, versies, rubrieks;
	dialog d;
	names=MakeStatic(2,2,b->Name);
	auteurs=MakeStatic(2,3,b->Auteur);
	uitgevers=MakeStatic(2,4,b->Uitgever);
	versies=MakeStatic(2,5,b->Versie);
	isbns=MakeStatic(42,5,b->ISBN);
	rubrieks=MakeStatic(2,6,b->Rubriek);
	k=MakeKeuze(1,35,9,2,"Delete book","no, just kidding");
	d=MakeDialog(7,"Delete book ?",names,auteurs,uitgevers,versies,isbns,rubrieks,k);
	if (RunDialog(d)==DIALOG_OK && GetKeuzeCurrent(k)==0)
	  {
	     
	     if (DELETEBOOK(b)!=DELETEBOOK_RP_OK) StatusLine("Failed to delete book");
	     else StatusLine("Book deleted");
	  }
	FreeDialogAndContents(d);
     }

void AddBookMenu(void)
     {
	int answer;
	char status[100];
	Book m;
	BookSubdialog bs;
	dialog d;
	bs=CreateBookSubdialog(m);
	while(1)
	  {
	     m=AllocateRecord(BOOK_FIELD_COUNT);
	     bs=CreateBookSubdialog(m);
	     d=MakeDialog(12,"Add book",bs.names.s,bs.names.i,bs.auteurs.s,bs.auteurs.i,
			  bs.uitgevers.s,bs.uitgevers.i,
			  bs.isbns.s,bs.isbns.i,bs.rubrieks.s,bs.rubrieks.i,
			  bs.positions.s,bs.positions.i);
	     if ((answer=RunDialog(d))==DIALOG_CANCEL) break;
	     sprintf(status,"Book added, exemplaar %d",ADDBOOK(m));
	     StatusLine(status);
	     FreeRecord((Record)m,BOOK_FIELD_COUNT);
	  }
	FreeRecord((Record)m,BOOK_FIELD_COUNT);
	FreeDialogAndContents(d);
	FreeInput(bs.versies.i);
	FreeStaticText(bs.versies.s);
     }

void DeleteBookMenu(void)
     {
	Book b;
	while (1)
	  {
	     b=SelectBookMenu("Welk boek deleten ?");
	     if (b) DeleteBook(b);
	     else break;
	  }
     }

void EditBookMenu(void)
     {
	Book b;
	while (1)
	  {
	     b=SelectBookMenu("Welk boek editeren ?");
	     if (b) EditBook(b);
	     else break;
	  }
     }

void FindBookMenu(void)
{
   SelectBookMenu(NULL);
}
