#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "misc.h"
#include "Cursus.h"
#include "CursussenActionServer.h"
#include "list.h"
#include "Messages.h"
#include "intersection.h"
#include "Table.h"
static Table CursusTable=NULL;

void InitCursussenServer(void)
{CursusTable=AllocateTable(CURSUS_FIELD_COUNT);}

void ADDCURSUS(char*Message)
     {
	Cursus c;
	c=(Cursus)RecvRecord(CURSUS_FIELD_COUNT);
	AddRecord(CursusTable,(Record)c);
	SendChar(ADDCURSUS_RP_OK);
	printf("CursussenServer: Added cursus '%s'\n",c->Name);
	FlushMessage();
     }

void DELETECURSUS(char*Message)
     {
	Cursus c=(Cursus)RecvRecord(CURSUS_FIELD_COUNT);
	DeleteRecord(CursusTable,(Record)c);
	SendChar(DELETECURSUS_RP_OK);
	printf("CursussenServer: Deleted cursus '%s'\n",c->Name);
	FreeRecord((Record)c,CURSUS_FIELD_COUNT);
	FlushMessage();
     }

void UPDATECURSUS(char*Message)
     {
	Cursus o,n;
	o=(Cursus)RecvRecord(CURSUS_FIELD_COUNT);
	n=(Cursus)RecvRecord(CURSUS_FIELD_COUNT);
	SendChar(UpdateRecord(CursusTable,(Record)o,(Record)n) ? UPDATECURSUS_RP_OK : UPDATEBOOK_RP_NOK);
	printf("CursusServer: Updated cursus '%s'\n",o->Name);
	FreeRecord(o,CURSUS_FIELD_COUNT);
	FreeRecord(n,CURSUS_FIELD_COUNT);
	FlushMessage();
     }

void FINDCURSUSSEN(char*Message)
     {
	Cursus b;
	int aantal;
	b=(Cursus)RecvRecord(CURSUS_FIELD_COUNT);
	SendChar(FINDCURSUSSEN_RP_OK);
	SendChunck(&aantal,4,dontfree);
	aantal=htonl(FindRecordsAndAnswer(CursusTable,(Record)b));
	FreeRecord(b,CURSUS_FIELD_COUNT);
	FlushMessage();
     }

void* SaveSingleCursus(void* who, void* common)
     {
	FILE * F=(FILE*)common;
	int size;
	char*r;
	Cursus m=(Cursus)who;
	assert(m);
	assert(F);
	size=RecordFormattedSize((Record)m,CURSUS_FIELD_COUNT);
	r=(char*)zmalloc(size);
	FormatRecord(r,(Record)m,CURSUS_FIELD_COUNT);
	if ((1!=fwrite(&size,sizeof(size),1,F)) || 
	    (size!=fwrite(r,1,size,F)))
	  {
	     printf("CursusServer: Couldn't write cursus outputfile\n");
	     exit(1);
	  };
	free(r);
	return who;
     }

int SaveCursussen(const char * name)
     {
	FILE* o;
	o=fopen(name,"wb");
	if (!o) return 0;
	TableForeach(CursusTable,SaveSingleCursus,o);
	fclose(o);
	printf("CursusServer: Saved cursussen\n");
	return 1;
     }

int LoadCursussen(const char*name)
     {
	int count;
	Cursus b;
	char*r;
	FILE*i;
	i=fopen(name,"rb");
	if(!i)  return 0;
	count=0;
	while(!feof(i))
	  {
	     int s;
	     if (fread(&s,sizeof(int),1,i)!=1) break;
	     r=zmalloc(s);
	     if (fread(r,s,1,i)!=1) return 0;
	     RawAddRecord(CursusTable,b=UnFormatRecord(r,CURSUS_FIELD_COUNT));
	       {
		  int nr=atoi(b->Key);
		  if (nr>CursusTable->lastkeynumber) CursusTable->lastkeynumber=nr;
	       }
	     free(r);
	     count++;
	  }
	fclose(i);
	printf("CursusServer: Loaded %d cursussen\n",count);
	return 1;
     }
