#include "ClientConnect.h"
#include "MemberActionClient.h"
#include "Messages.h"
#include "misc.h"
#include "myio.h"
#include <ctype.h>
#include "intersection.h"

int ADDMEMBER(Member m)
/* 0 indien mislukt */
/* 1 indien gelukt */
     {
	assert(m);
	printf("Entering Sendchar\n"); fflush(stdout);
	SendChar(ADDMEMBER_RQ);
	printf("Leaving Sendchar\n"); fflush(stdout);
	printf("Entering SendRecord\n"); fflush(stdout);
	SendRecord((Record)m,MEMBER_FIELD_COUNT);
	printf("Leaving SendRecord\n"); fflush(stdout);
	FlushMessage();
	return (RecvChar()!=ADDMEMBER_RP_EXISTS);
     }

int DELETEMEMBER(Member m)
     {
	SendChar(DELETEMEMBER_RQ);
	SendRecord((Record)m,MEMBER_FIELD_COUNT);
	FlushMessage();
	return RecvChar();
     }

int UPDATEMEMBER(Member b, Member n)
     {
	assert(b && n);
	SendChar(UPDATEMEMBER_RQ);
	SendRecord((Record)b,MEMBER_FIELD_COUNT);
	SendRecord((Record)n,MEMBER_FIELD_COUNT);
	FlushMessage();
	return RecvChar();
     }

MemberSearchResult FINDMEMBERS(Member b)
     {
	int aantal;
	MemberSearchResult result;
	assert(b);
	SendChar(FINDMEMBERS_RQ);
	SendRecord((Record)b,MEMBER_FIELD_COUNT);
	FlushMessage();
	if (RecvChar()!=FINDMEMBERS_RP_OK) 
	  {
	     result.result=NULL;
	     result.result=0;
	     return result;
	  }
	/* dan nu eens converteren naar een waardevol reekske */
	aantal=RecvInteger();
	assert(aantal>=0);
	if (!aantal) result.result=NULL;
	else result.result=(Member*)zmalloc(sizeof(Member)*aantal);
	result.aantal=aantal;
	while(aantal>0)
	  {
	     aantal--;
	     result.result[aantal]=(Member)RecvRecord(MEMBER_FIELD_COUNT);
	  }
	return result;
     }

typedef struct sMemberSubdialog {
   inputandstatic numbers,names,rolnrs,orients,emails,locall1s,tellocals,
   homel1s,telhomes;
   input locall2i, homel2i;
} MemberSubdialog;


static void CurrentMChanged(Member r,MemberSubdialog*bs)
     {
	assert(bs && r);
	PasteInputString(bs->numbers.i,r->Number);
	PasteInputString(bs->names.i,r->Name);
	PasteInputString(bs->rolnrs.i,r->RolNummer);
	PasteInputString(bs->orients.i,r->Orientation);
	PasteInputString(bs->emails.i,r->Email);
	PasteInputString(bs->locall1s.i,r->LocalL1);
	PasteInputString(bs->locall2i,r->LocalL2);
	PasteInputString(bs->tellocals.i,r->TelLocal);
	PasteInputString(bs->homel1s.i,r->HomeL1);
	PasteInputString(bs->homel2i,r->HomeL2);
	PasteInputString(bs->telhomes.i,r->TelHome);
     }

MemberSubdialog CreateMemberSubdialog(Member m)
     {
	MemberSubdialog bs;
	bs.numbers=MakeInputAndStatic(2,2,10,"Number ",&m->Number);
	bs.names=MakeInputAndStatic(2,3,70,"Name ",&m->Name);
	bs.rolnrs=MakeInputAndStatic(2,4,15,"Rolnummer ",&m->RolNummer);
	bs.orients=MakeInputAndStatic(30,4,10,"Orientation ",&m->Orientation);
	bs.emails=MakeInputAndStatic(2,5,30,"e-mail ",&m->Email);
	bs.locall1s=MakeInputAndStatic(2,6,40,"Local adress ",&m->LocalL1);
	bs.locall2i=MakeInput(15,7,40,&m->LocalL2);
	bs.tellocals=MakeInputAndStatic(2,8,20,"Tel, local ",&m->TelLocal);
	bs.homel1s=MakeInputAndStatic(2,9,40,"Thuisadres ",&m->HomeL1);
	bs.homel2i=MakeInput(13,10,40,&m->HomeL2);
	bs.telhomes=MakeInputAndStatic(2,11,20,"Tel, thuis ",&m->TelHome);
	return bs;
     }

static void MKey(int c, Member r,dialog d)
     {
	if (c=='e' || c=='E')
	  {
	     EditMember(r);
	     RedrawDialog(d);
	  }
	if (c=='d' || c=='D')
	  {
	     DeleteMember(r);
 	     RedrawDialog(d);
	  }
     }

Member SelectMemberMenu(char* Title)
     {
	int answer;
	Member result=NULL;
	Member m, memberheader;
	MemberSubdialog bs;
	listbox lb;
	dialog d;

	memberheader=(Member)AllocateRecord(MEMBER_FIELD_COUNT);
	memberheader->Key="";
	memberheader->Number=" Nr ";
	memberheader->Orientation=" Orientation ";
	memberheader->Name="         Name           ";
	memberheader->RolNummer="   rolnummer   ";
	memberheader->Email="     e-mail      ";
	memberheader->LocalL1="   Local adress           ";
	memberheader->LocalL2="                            ";
	memberheader->TelLocal="       Tel        ";
	memberheader->HomeL1="    Home adress              ";
	memberheader->HomeL2="                             ";
	memberheader->TelHome="         Tel        ";
	m=(Member)AllocateRecord(MEMBER_FIELD_COUNT);
	bs=CreateMemberSubdialog(m);
	lb=MakeListBox(2,14,76,8,NULL,10,0,memberheader);
	SetListBoxCurrentChangedCallback(lb,CurrentMChanged,&bs);
	d=MakeDialog(21,(!Title ? "Search Members" : Title),
		     bs.numbers.s,bs.numbers.i,bs.names.s,bs.names.i,
		     bs.rolnrs.s,bs.rolnrs.i,bs.orients.s,bs.orients.i,bs.emails.s,bs.emails.i,
		     bs.locall1s.s,bs.locall1s.i,bs.locall2i,bs.tellocals.s,bs.tellocals.i,
		     bs.homel1s.s,bs.homel1s.i,bs.homel2i,bs.telhomes.s,bs.telhomes.i,lb);
	if (!Title) SetListBoxKeyCallback(lb,MKey,d);
	while(1)
	  {
	     if ((answer=RunDialog(d))==DIALOG_CANCEL) break;
	       {
		  MemberSearchResult sr=FINDMEMBERS(m);
		  SetListBoxContents(lb,sr.result,sr.aantal);
		  if (sr.aantal==0)
		    StatusLine("Geen members gevonden");
		  else
		    {
		       SetDialogCurrent(d,20); /* das de listbox, op verzoek van Sven */
		       if (Title && sr.aantal==1)
			 {
			    result=sr.result[0];
			    break;
			 }
		       else result=NULL;
		    }
	       }
	  }
	FreeRecord((Record)m,MEMBER_FIELD_COUNT);
	FreeDialogAndContents(d);
	return result;
     }

void EditMember(Member b)
     {
	Member n;
	MemberSubdialog bs;
	dialog d;
	n=(Member)AllocateRecord(MEMBER_FIELD_COUNT);
	PasteRecord((Record)n,(Record)b,MEMBER_FIELD_COUNT);
	bs=CreateMemberSubdialog(n);
	while (1)
	  {
	     d=MakeDialog(20,"Edit member",bs.numbers.s,bs.numbers.i,bs.names.s,bs.names.i,
			  bs.rolnrs.s,bs.rolnrs.i,bs.orients.s,bs.orients.i,bs.emails.s,bs.emails.i,
			  bs.locall1s.s,bs.locall1s.i,bs.locall2i,bs.tellocals.s,bs.tellocals.i,
			  bs.homel1s.s,bs.homel1s.i,bs.homel2i,bs.telhomes.s,bs.telhomes.i);
	     if (RunDialog(d)==DIALOG_CANCEL) break;
	     if (UPDATEMEMBER(b,n)!=UPDATEMEMBER_RP_OK) StatusLine("Failed to update member");
	     else 
	       {
		  PasteRecord((Record)b,(Record)n,MEMBER_FIELD_COUNT);
		  StatusLine("Member updated successfully");
		  break;
	       }
	  }
     	FreeRecord((Record)n,MEMBER_FIELD_COUNT);
	FreeDialogAndContents(d);
     }

void DeleteMember(Member b)
     {
	keuze k;
	statictext number,name,rolnr,orient,tellocal, locall1, locall2, homel1, homel2, telhome,email;
	dialog d;
	number=MakeStatic(2,2,b->Number);
	name=MakeStatic(2,3,b->Name);
	email=MakeStatic(2,3,b->Email);
	rolnr=MakeStatic(2,4,b->RolNummer);
	orient=MakeStatic(2,5,b->Orientation);
	locall1=MakeStatic(2,6,b->LocalL1);
	locall2=MakeStatic(2,7,b->LocalL2);
	tellocal=MakeStatic(2,8,b->TelLocal);
	homel1=MakeStatic(2,9,b->HomeL1);
	homel2=MakeStatic(2,10,b->HomeL2);
	telhome=MakeStatic(2,11,b->TelHome);
	
	k=MakeKeuze(1,35,15,2,"Delete Member","no, just kidding");
	d=MakeDialog(10,"Delete Member ?", number, name, email, locall1, locall2, tellocal,
		     homel1, homel2, telhome, k);
	if (RunDialog(d)==DIALOG_OK && GetKeuzeCurrent(k)==0)
	  {
	     if (DELETEMEMBER(b)!=DELETEMEMBER_RP_OK) StatusLine("Failed to delete member");
	     else StatusLine("Member deleted");
	  }
	FreeDialogAndContents(d);
     }

int ValidateMember(Member m)
{
   char d[320],*r=d,*s;
   int nr=0;
   /* 0. de interne representatie moet ok zijn */
   assert(ValidRecord((Record)m,MEMBER_FIELD_COUNT));
   /* 1. het membernummer moet bestaan uit <num> of l<num> */
   if (strlen(m->Number)>318)
     {
	StatusLine("Zijt gij zot of wat ???, een number moet onder de 320 tekens !");
	return 0;
     }
   s=m->Number;
   while(*s && !isdigit(*s)) *(r++)=*(s++);
   if (!*s) 
     {
	StatusLine("Number moet een number bevatten. Twit.");
	return 0;
     }
   while(*s && isdigit(*s)) 
     {
	nr*=10;
	nr+=*s++-'0';
     }
   sprintf(r,"%03d",nr);
   PasteString((Record)m,d,1);
   /* 2. Name mag niet leeg zijn */
   if (strlen(m->Name)==0) 
     {
	StatusLine("Het name-veld moet ingevuld zijn");
	return 0;
     }
   return 1;
}


void AddMemberMenu(void)
     {
	int answer;
	Member m=NULL;
	MemberSubdialog bs;
	dialog d;
	bs=CreateMemberSubdialog(m);
	while(1)
	  {
	     if (!m) m=(Member)AllocateRecord(MEMBER_FIELD_COUNT);
	     
	     bs=CreateMemberSubdialog(m);
	     d=MakeDialog(20,"Add member",bs.numbers.s,bs.numbers.i,bs.names.s,bs.names.i,
			  bs.rolnrs.s,bs.rolnrs.i,bs.orients.s,bs.orients.i,bs.emails.s,bs.emails.i,
			  bs.locall1s.s,bs.locall1s.i,bs.locall2i,bs.tellocals.s,bs.tellocals.i,
			  bs.homel1s.s,bs.homel1s.i,bs.homel2i,bs.telhomes.s,bs.telhomes.i);
	     if ((answer=RunDialog(d))==DIALOG_CANCEL) break;
	     /* controleer of maak zn geldigheid */
	     if (ValidateMember(m))
	       {
		  if (ADDMEMBER(m)) 
		    {
		       StatusLine("Member added");
		       FreeRecord((Record)m,MEMBER_FIELD_COUNT);
		       m=NULL;
		    }
		  else StatusLine("Membernumber not unique !!!!");
	       };
	     FreeDialogAndContents(d);
	  }
	FreeRecord((Record)m,MEMBER_FIELD_COUNT);
	FreeDialogAndContents(d);
     }

void DeleteMemberMenu(void)
     {
	Member b;
	while (1)
	  {
	     b=SelectMemberMenu("Select member to delete");
	     if (b) DeleteMember(b);
	     else break;
	  }
     }

void EditMemberMenu(void)
     {
	Member b;
	while (1)
	  {
	     b=SelectMemberMenu("Select member to edit");
	     if (b) EditMember(b);
	     else break;
	  }
     }

void FindMemberMenu(void)
{
   SelectMemberMenu(NULL);
}
