#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "misc.h"
#include "Member.h"
#include "MemberActionServer.h"
#include "list.h"
#include "Messages.h"
#include "intersection.h"
#include "Table.h"

Table MemberTable=NULL;

void InitMemberServer(void)
     {
	MemberTable=AllocateTable(MEMBER_FIELD_COUNT);
     }

static int checknumber(Member m, String nr)
     {
	if (strcasecmp(nr,m->Number)==0) return 1;
	else return 0;
     }

int ExistsMemberNr(String nr)
     {
	if (!TableFindFirst(MemberTable,checknumber,nr)) return 0;
	else return 1;
     }

Record TableFindFirst(Table t, int(*func)(Record r,void*Common),void*common);

void ADDMEMBER(char*Message)
     {
	Member m;
	char a=ADDMEMBER_RP_OK;
	m=RecvRecord(MEMBER_FIELD_COUNT);
	PrintRecord(m,MEMBER_FIELD_COUNT);
	/* zoek eerst eens op of er dergelijk member reeds is */
	if (ExistsMemberNr(m->Number)) a=ADDMEMBER_RP_EXISTS;
	else AddRecord(MemberTable,(Record)m);
	SendChar(a);
	if (a==ADDMEMBER_RP_OK) 
	  printf("MemberServer: Added member '%s'\n",m->Name);
	FlushMessage();
     }

void DELETEMEMBER(char*Message)
     {
	Member m=RecvRecord(MEMBER_FIELD_COUNT);
	DeleteRecord(MemberTable,(Record)m);
	SendChar(DELETEMEMBER_RP_OK);
	printf("MemberServer: Deleted member '%s'\n",m->Name);
	FreeRecord(m,MEMBER_FIELD_COUNT);
	FlushMessage();
     }

void UPDATEMEMBER(char*Message)
     {
	Member o,n;
	char a;
	o=(Member)RecvRecord(MEMBER_FIELD_COUNT);
	n=(Member)RecvRecord(MEMBER_FIELD_COUNT);
	a=UpdateRecord(MemberTable,(Record)o,(Record)n) ? UPDATEMEMBER_RP_OK : UPDATEBOOK_RP_NOK;
	SendChar(a);
	printf("MemberServer: Updated member '%s'\n",o->Name);
	FreeRecord(o,MEMBER_FIELD_COUNT);
	FreeRecord(n,MEMBER_FIELD_COUNT);
	FlushMessage();
     }

void FINDMEMBERS(char*Message)
     {
	Member b;
	int aantal;
	b=RecvRecord(MEMBER_FIELD_COUNT);
	SendChar(FINDMEMBERS_RP_OK);
	SendChunck(&aantal,4,dontfree);
	aantal=htonl(FindRecordsAndAnswer(MemberTable,(Record)b));
	FreeRecord(b,MEMBER_FIELD_COUNT);
	printf("Ready to flush message...\n"); fflush(stdout);
	FlushMessage();
	printf("Flush message...\n"); fflush(stdout);
     }

void* SaveSingleMember(void* who, void* common)
     {
	FILE * F=(FILE*)common;
	int size;
	char*r;
	Member m=(Member)who;
	assert(m);
	assert(F);
	size=RecordFormattedSize((Record)m,MEMBER_FIELD_COUNT);
	r=(char*)zmalloc(size);
	FormatRecord(r,(Record)m,MEMBER_FIELD_COUNT);
	if ((1!=fwrite(&size,sizeof(size),1,F)) || 
	    (size!=fwrite(r,1,size,F)))
	  {
	     printf("MemberServer: Couldn't write member outputfile\n");
	     exit(1);
	  };
	free(r);
	return who;
     }

int SaveMembers(const char * name)
     {
	FILE* o;
	o=fopen(name,"wb");
	if (!o) return 0;
	TableForeach(MemberTable,SaveSingleMember,o);
	fclose(o);
	printf("MemberServer: Saved members\n");
	return 1;
     }

int LoadMembers(const char*name)
     {
	int count;
	Member b;
	char*r;
	FILE*i;
	i=fopen(name,"rb");
	if(!i)  return 0;
	count=0;
	while(!feof(i))
	  {
	     int s;
	     if (fread(&s,sizeof(int),1,i)!=1) break;
	     r=zmalloc(s);
	     if (fread(r,s,1,i)!=1) return 0;
	     RawAddRecord(MemberTable,b=UnFormatRecord(r,MEMBER_FIELD_COUNT));
	       {
		  int nr=atoi(b->Key);
		  if (nr>MemberTable->lastkeynumber) MemberTable->lastkeynumber=nr;
	       }
	     free(r);
	     count++;
	  }
	fclose(i);
	printf("MemberServer: Loaded %d members\n",count);
	return 1;
     }
