#include <stdlib.h>
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ncurses/ncurses.h>

#include "myio.h"
#include "ClientConnect.h"
#include "BookActionClient.h"
#include "MemberActionClient.h"
#include "UitleningenActionClient.h"
#include "Book.h"
#include "Messages.h"
#include "list.h"
#include "misc.h"
#include "Uitlening.h"

void UitleenMenu(void)
     {
	char*Warranty=NULL;
	statictext names,auteurs, uitgevers, isbns, versies, rubrieks;
	statictext number,name,rolnr,orient,tellocal, locall1, locall2, homel1, homel2, telhome,email;
	inputandstatic warrantysi;
	dialog d;
	Member m;
	Book b;

	m=SelectMemberMenu("Aan wie een boek uitlenen ?");
	if (!m) return;
	b=SelectBookMenu("Welk boek wordt uitgeleend ?");
	if (!b) return;

	names=MakeStatic(2,2,b->Name);
	auteurs=MakeStatic(2,3,b->Auteur);
	uitgevers=MakeStatic(2,4,b->Uitgever);
	versies=MakeStatic(2,5,b->Versie);
	isbns=MakeStatic(42,5,b->ISBN);
	rubrieks=MakeStatic(2,6,b->Rubriek);

	number=MakeStatic(2,7,m->Number);
	name=MakeStatic(2,8,m->Name);
	email=MakeStatic(2,9,m->Email);
	rolnr=MakeStatic(2,10,m->RolNummer);
	orient=MakeStatic(2,11,m->Orientation);
	locall1=MakeStatic(2,12,m->LocalL1);
	locall2=MakeStatic(2,13,m->LocalL2);
	tellocal=MakeStatic(2,14,m->TelLocal);
	homel1=MakeStatic(2,15,m->HomeL1);
	homel2=MakeStatic(2,16,m->HomeL2);
	telhome=MakeStatic(2,17,m->TelHome);
	warrantysi=MakeInputAndStatic(2,20,50,"Warranty: ",&Warranty);
	d=MakeDialog(17,"Geef warranty in voor deze uitlening",names,auteurs,uitgevers,versies,isbns,rubrieks,
		     number, name, email, locall1, locall2, tellocal,
		     homel1, homel2, telhome, warrantysi.s, warrantysi.i);
	if (RunDialog(d)==DIALOG_OK)
	  {
	     LEENUIT(m,b,Warranty);
	     StatusLine("Boek uitgeleend");
	  }
	FreeDialogAndContents(d);
	FreeRecord((Record)m,MEMBER_FIELD_COUNT);
	FreeRecord((Record)b,BOOK_FIELD_COUNT);
	free(Warranty);
     }

Uitlening SelectUitleningMenu(Member m, char* Title)
     {
	Uitlening result=NULL;
	UitleningSearchResult uitleningheader;
	listbox lb;
	dialog d;
	struct UitleningenSearchResult sr=FINDUITLENINGEN(m);
	if (sr.aantal==0) 
	  {
	     StatusLine("Geen boeken uitgeleend aan dit lid");
	     return NULL;
	  }
	uitleningheader=(UitleningSearchResult)AllocateRecord(BOOK_FIELD_COUNT+MEMBER_FIELD_COUNT+UITLENING_FIELD_COUNT);
	uitleningheader->B.Key=" nr ";
	uitleningheader->B.ISBN="     ISBN      ";
	uitleningheader->B.Name="                     Name                      ";
	uitleningheader->B.Auteur="          Auteur(s)      ";
	uitleningheader->B.Uitgever="          Uitgever         ";
	uitleningheader->B.Versie="  Exemplaar  ";
	uitleningheader->B.Rubriek="  Type  ";
	uitleningheader->B.Position="     Position    ";
	
	uitleningheader->u.Warranty="  Warranty  ";
	uitleningheader->u.Date="         Date        ";
	
	lb=MakeListBox(2,2,76,15,NULL,13,0,uitleningheader);
	SetListBoxContents(lb,sr.result,sr.aantal);
	d=MakeDialog(1,Title,lb);
	if (RunDialog(d)==DIALOG_OK)
	  result=&sr.result[GetListBoxCurrent(lb)]->u;
	FreeDialogAndContents(d);
	return result;
     }

void BringBookBack(void)
     {
	Uitlening u;
	Member m;
	m=SelectMemberMenu("Welk lid bezit het bewuste boek ?");
	if (!m) return;
	while (u=SelectUitleningMenu(m,"Welk boek wordt teruggebracht ?"))
	  {
	     DELETEUITLENING(u);
	     StatusLine("Uitlening deleted");
	  }
     }

void SendBugReport()
     {
	int pid;
	DoneMyIo();
	if ((pid=fork())==0)
	  {
	     execlp("elm","elm","-s igtool","werner@igwe8.vub.ac.be",0);
	     exit(0);
	  }
	waitpid(pid,0,0);
	InitMyIo();
     }

void MainMenu(void)
     {
	int answer;
	keuze k;
	dialog d;
	k=MakeKeuze(0,5,5,6
		    ,"Find book"
		    ,"Add Member"
		    ,"Edit Member"
		    ,"Borrow a book"
		    ,"Bring book back"
		    ,"Send bug report");
	d=MakeDialog(1,"Main menu",k);
	while(1)
	  {
	     answer=RunDialog(d);
	     if (answer==DIALOG_CANCEL) break;
	     switch(GetKeuzeCurrent(k))
	       {
		case 0 : FindBookMenu(); break;
		case 1 : AddMemberMenu(); break;
		case 2 : EditMemberMenu(); break;
		case 3 : UitleenMenu(); break;
		case 4 : BringBookBack(); break;
		case 5 : SendBugReport(); break;
		default: assert(0);
	       }
	  }
	FreeKeuze(k);
	FreeDialog(d);
     }

void main(void)
     {
	InitMyIo();
	InitClientConnect();
	MainMenu();
	DoneMyIo();
     } 
