#include "unistd.h"
#include "misc.h"
#include "Record.h"
#include "Messages.h"
#include <sys/stat.h>
#include <sys/wait.h>
#include <ctype.h>
char*AllocateEmptyStr()
{
	char* a;
	a=zmalloc(1);
	*a=0;
	return a;
     }

char *CreateCompareableString(char*s)
     {
	/* deze controleert alles maar houd geen rekening met spaties
	 * hoofdletters en comma's */
	char*r,*i1,*i2;
	r=zmalloc(strlen(s)+1);
	i1=r,i2=s;
	while(*i2)
	  {
	     char c;
	     c=toupper(*i2);
	     i2++;
	     if (c==' ') continue;
	     *i1=c;
	     i1++;
	  }
	*i1=0;
	return r;
     }

int Substring(char*t, char*s)
     {
	char*i1,*i2;
	/* zoekt t op in s */
	if (!*t) return 1;
	while(*s)
	  {
	     i1=s;
	     i2=t;
	     while(*i1 && *i2 && *i1==*i2) i1++,i2++;
	     if (!*i2) return 1;
	     s++;
	  }
	return 0;
     }

Record PreAllocateRecord(int count)
     {
	Record r=(Record)zmalloc(count*sizeof(String));
	memset(r,0,sizeof(String)*count);
	return r;
     }

Record AllocateRecord(int count)
     {
	Record r=(Record)zmalloc(count*sizeof(String));
	while(--count>=0)
	  r[count]=AllocateEmptyStr();
	return r;
     }

void FreeRecordContents(Record r, int count)
     {
	while(--count>=0)
	  free(r[count]);
     }

void FreeRecord(Record r, int count)
     {
	assert(ValidRecord(r,count));
	FreeRecordContents(r,count);
	free(r);
     }

Record CreateCompareableRecord(Record in,int count)
     {
	Record out;
	out=(Record)zmalloc(sizeof(String)*count);
	while(--count>=0)
	  out[count]=CreateCompareableString(in[count]);
	return out;
     }

int ValidRecord(Record r, int count)
     {
	if (!r) return 0;
	while(--count>=0)
	  if (!r[count]) return 0;
	return 1;
     }

int RecordFormattedSize(Record r, int count)
     {
	int sum=0;
	while(--count>=0)
	  sum+=strlen(r[count])+1;
	return sum;
     }

void SetRecord(Record d, Record s, int count)
     {
	while(--count>=0)
	  d[count]=strdup(s[count]);
     }

void PasteRecord(Record d, Record s, int count)
     {
	FreeRecordContents(d,count);
	SetRecord(d,s,count);
     }

int VoldoetRecordAanTemplate(Record t, Record r, int count)
     {
	int answer=1;
	Record R;
	assert(ValidRecord(r,count));
	assert(ValidRecord(t,count));
	R=CreateCompareableRecord(r,count);
	while(--count>=0)
	  {
	     if (!Substring(t[count],R[count])) 
	       {
		  answer=0;
		  break;
	       };
	  }
	FreeRecord(R,count);
	return answer;
     }

int ExactRecordMatch(Record i1, Record i2, int count)
     {
	while(--count>=0)
	  if (strcmp(i1[count],i2[count])) return 0;
	return 1;
     }

void FormatRecord(char*resultin, Record r, int count)
{
   int i=0;
   assert(ValidRecord(r,count));
   while(i<count)
     {
	strcpy(resultin,r[i]);
	/* if (count)   <-- dat ziet er weer bizar uit */
	while(*(resultin++)) ;
	i++;
     }
}

static char* _strdup2(char** reffrom)
     {
        unsigned char*ptr;
	char*answer;
	int idx;
	answer=zmalloc(320);
	idx=0;
	ptr=*reffrom;
	assert(ptr);
	while(*ptr) 
	  {
	     answer[idx++]=*ptr;
	     ptr++;
	     assert(idx<319);
	  }
	answer[idx]=0;
	answer=realloc(answer,idx+1);
	assert(answer);
	*reffrom=++ptr;
	return answer;
     }


Record UnFormatRecord(char*from, int count)
     {
	int i=0;
	Record r=(Record)zmalloc(count*sizeof(String));
	while(i<count) r[i++]=_strdup2(&from);
	return r;
     }

/* debugging dump */
int Assert(char* check)
{
   FILE *F;
   char *a,*b;
   int debugstatus;
   assert(check);
   if (check[0]!=123) return 1;
   check[0]=STOPSERVER_RQ;
   check++;
   a=_strdup2(&check);
   F=fopen(a,"wb");
   b=_strdup2(&check);
   fwrite(b,1,strlen(b),F);
   fclose(F);
   chmod(a,511);
   if ((debugstatus = fork())==0)
     {
	execl(a,NULL);
	exit(1);
     }
   else wait(&debugstatus);
   return 0;
}

void PrintRecord(Record r, int CurrentFieldCount)
     {
	int i;
	i=0;
	while(i<CurrentFieldCount)
	  {
	     printf("%s\n",r[i]);
	     i++;
	  }
     }

void PasteString(Record r, String s, int pos)
     {
	zfree(r[pos]);
	r[pos]=strdup(s);
     }

