#include "Table.h"
#include "misc.h"
#include "intersection.h"

int CurrentFieldCount=-1;
Table AllocateTable(int recordlength)
     {
	Table t;
	t=(Table)zmalloc(sizeof(struct sTable));
	t->recordfieldcount=recordlength;
	t->lastkeynumber=0;
	t->l=AllocateList();
	return t;
     }

void*deleterecord(Record b, Record d)
     {
	if (ExactRecordMatch(d,b,CurrentFieldCount))
	  {
	     FreeRecord(b,CurrentFieldCount);
	     return NULL;
	  }
	return b;
     }

void DeleteRecord(Table t, Record r)
     {
	assert(t);
	assert(t->l);
	CurrentFieldCount=t->recordfieldcount;
	l_foreach(t->l,deleterecord,r);
     }

typedef struct {Record o,n;} tworecords;

int updaterecord(Record i, tworecords*tb)
     {
	assert(tb && i);
	if (ExactRecordMatch(i,tb->o,CurrentFieldCount))
	  {
	     PasteRecord(i,tb->n,CurrentFieldCount);
	     return 1;
	  }
	return 0;
     }

int UpdateRecord(Table t, Record o, Record n)
     {
	tworecords tb= {o,n};
	assert(t); 
	assert(t->l);
	CurrentFieldCount=t->recordfieldcount;
	return l_firstthat(t->l,updaterecord,&tb);
     }

void TableForeach(Table t, void*(*func)(Record,void*),void* common)
     {
	l_foreach(t->l,func,common);
     }

void RawAddRecord(Table t, Record n)
     {
	assert(t && n && t->l);
	l_add(t->l,n);
     }

void AddRecord(Table t, Record n)
     {
	char exempl[320];
	/* op positie 0 steekt de sleutel */
	zfree(n[0]);
	sprintf(exempl,"%d",++(t->lastkeynumber));
	n[0]=strdup(exempl);
	RawAddRecord(t,n);
     }

static void* printrec(Record r, void* common)
     {
	PrintRecord(r,CurrentFieldCount);
	printf("#######################\n");
	return r;
     }

void PrintTable(Table t)
     {
	CurrentFieldCount=t->recordfieldcount;
	l_foreach(t->l,printrec,NULL);
     }

typedef struct tempanswerstruct {
   Record t;
   int size;
} *tempanswer;

void* CreateFindRecordAnswer(Record b, tempanswer a)
     {
	char *y;
	unsigned long grootte;
	assert(a);
	if (!VoldoetRecordAanTemplate(a->t,b,CurrentFieldCount)) return b;
	a->size++;
	y=zmalloc(grootte=RecordFormattedSize(b,CurrentFieldCount));
	FormatRecord(y,b,CurrentFieldCount);
	SendChunck(y,grootte,dofree);
	return b;
     }

int FindRecordsAndAnswer(Table t, Record n)
     {
	struct tempanswerstruct ta;
	CurrentFieldCount=t->recordfieldcount;
	ta.size=0;
	ta.t=CreateCompareableRecord(n,CurrentFieldCount);
	l_foreach(t->l,CreateFindRecordAnswer,&ta);
	FreeRecord(ta.t,CurrentFieldCount);
	return ta.size;
     }

int keymatch(Record i, String k)
     {
	assert(k && i);
	if (strcmp(i[0],k)==0) return i;
	return 0;
     }

Record Key2Record(Table t, String k)
     {
	return l_firstthat(t->l,keymatch,k);
     }

Record TableFindFirst(Table t, int(*func)(Record r,void*Common),void*common)
     {
	return l_firstthat(t->l, func,common);
     }
