#include "misc.h"
#include <assert.h>
#include "intersection.h"
#include <netinet/in.h>
#include "list.h"
List AnswerList;
char* CurrentReceived=NULL;

void InitIntersection()
     {
	AnswerList=AllocateList();
     }

typedef struct sChunck  {
   unsigned long size;
   void* contents;
   freefunc FreeFunc;
} * Chunck;


extern writenet(void* watte, int datte);
static void* sendchunck_aux(void* cel, void * ignoer)
{
   Chunck c=(Chunck)cel;
   assert(c && c->contents);
   writenet(c->contents,c->size);
   if (c->FreeFunc) c->FreeFunc(c->contents);
   zfree(cel);
   return NULL; /* altijd verwijderen */
}

static void* calcchuncksum(void* cel, unsigned long *s)
     {
	Chunck c=(Chunck)cel;
	assert(c);
	(*s)+=c->size;
	return cel; 
     }

void(*dontfree)(void*)=NULL;
void SendChunck(void* chunck, unsigned long size, freefunc f)
     {
	Chunck c;
	c=(Chunck)zmalloc(sizeof(struct sChunck));
	c->size=size;
	c->contents=chunck;
	c->FreeFunc=f;
	l_tailadd(AnswerList,c);
     }

char* RecvChunck(int count)
     {
	char* toreturn;
	assert(CurrentReceived);
	toreturn=CurrentReceived;
	CurrentReceived+=count;
	return toreturn;
     }

void SendRecord(Record r, int count)
     {
	unsigned long s;
	char * y;
	y=zmalloc(s=RecordFormattedSize(r,count));
	FormatRecord(y,r,count);
	SendChunck(y,s,dofree);
     }

Record RecvRecord(int fieldcount)
     {
	Record r;
	assert(fieldcount);
	r=UnFormatRecord(CurrentReceived,fieldcount);
	CurrentReceived+=RecordFormattedSize(r,fieldcount);
	return r;
     }


void SendInteger(int zegetis)
     {
	int *t;
	t=(int*)zmalloc(4);
	*t=htonl(zegetis);
	SendChunck(t,4,dofree);
     }

int RecvInteger()
     {
	int *t;
	t=(int*)RecvChunck(4);
	return ntohl(*t);
     }

void SendChar(char zegetis)
     {
	char *t;
	t=(char*)zmalloc(1);
	*t=zegetis;
	SendChunck(t,1,dofree);
     }

char RecvChar()
     {
	return *RecvChunck(1);
     }

char* RecvString()
     {
	char *a=strdup(CurrentReceived);
	RecvChunck(strlen(a)+1);
	return a;
     }

void SendString(char* a)
     {
	char*b=strdup(a);
	SendChunck(b,strlen(b)+1,dofree);
     }

void DoFlushMessage(void)
     {
	unsigned int s=0;
	assert(AnswerList);
	ListForeach(AnswerList,calcchuncksum,&s);
	s=htonl(s);
	writenet(&s,sizeof(s));
	l_foreach(AnswerList,sendchunck_aux,NULL);
	assert(l_empty(AnswerList));
     }
