#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include "list.h"
#include "misc.h"
List AllocateList(void)
     {
	List l;
	l=(List)zmalloc(sizeof(struct sList));
	assert(l);
	l->firstelement=l->lastelement=NULL;
	return l;
     }

void FreeList(List l)
     {
	ListCel cur;
	assert(l);
	cur=l->firstelement;
	while(cur)
	  {
	     ListCel temp=cur->next;
	     free(cur);
	     cur=temp;
	  }
     }


void l_add(List l, void* watte)
     {
	ListCel c;
	c=(ListCel)zmalloc(sizeof(struct sListCel));
	c->contents=watte;
	c->next=l->firstelement;
	l->firstelement=c;
	if (!l->lastelement) l->lastelement=c;
     }

void l_tailadd(List l, void* watte)
     {
	ListCel c;
	if (!l->lastelement) 
	  {
	     l_add(l,watte);
	     return;
	  }
	c=(ListCel)zmalloc(sizeof(struct sListCel));
	c->contents=watte;
	c->next=NULL;
	l->lastelement->next=c;
	l->lastelement=c;
     }

void l_foreach(List l, foreachfunc func, void* common)
     {
	ListCel cur,prev;
	void *t;
	assert(l);
	prev=NULL;
	cur=l->firstelement;
	while(cur)
	  {
	     t=func(cur->contents,common);
	     if (!t)
	       {
		  if (!prev) 
		    {
		       l->firstelement=cur->next;
		       cur->next=NULL;
		       free(cur);
		       if (l->lastelement==cur) l->lastelement=prev;
		       cur=l->firstelement;
		    }
		  else
		    {
		       prev->next=cur->next;
		       cur->next=NULL;
		       free(cur);
		       if (l->lastelement==cur) l->lastelement=prev;
		       cur=prev->next;
		    }
	       }
	     else 
	       {
		  cur->contents=t;
		  prev=cur;
		  cur=cur->next;
	       }
	  }
     }

void* l_firstthat(List l, void*(*func)(void* who,void*common), void* common)
     {
	ListCel cur;
	void*t;
	assert(l);
	cur=l->firstelement;
	while(cur)
	  {
	     if ((t=func(cur->contents,common))!=0) return t;
	     cur=cur->next;
	  }
	return 0;
     }

void* l_first(List l)
     {
	assert(l);
	assert(l->firstelement);
	return l->firstelement;
     }
