#ifndef MYIO_H
#define MYIO_H

void InitMyIo(void);
void DoneMyIo(void);

struct keuzestruct;
typedef struct keuzestruct *keuze;
keuze MakeKeuze(int pos, int x, int y, int aantal,...);
int GetKeuzeCurrent(keuze);

struct inputstruct;
typedef struct inputstruct *input;
input MakeInput(int x, int y, int aantal,char**str);
void SetInputString(input i, char** str);
void PasteInputString(input i, char* str);

struct listboxstruct;
typedef struct listboxstruct *listbox;
int GetListBoxCurrent(listbox lb);
listbox MakeListBox(int x, int y, int dx, int dy,
		    char***contents, int breedte, int hoogte, char**Header);
void SetListBoxContents(listbox lb,char***contents, int hoogte);
void SetListBoxCurrentChangedCallback(listbox,void(*callback)(void*record,void*common),void*common);
void SetListBoxKeyCallback(listbox,void(*callback)(int c,void*record,void*common),void*common);

#define DIALOG_CANCEL -1
#define DIALOG_OK -2
struct dialogstruct;
typedef struct dialogstruct *dialog;
dialog MakeDialog(int aantal, char* Title,...);
int RunDialog(dialog d);
void SetDialogCurrent(dialog d, int i);
void RedrawDialog(dialog d);
void FreeDialogAndContents(dialog d);

struct statictextstruct;
typedef struct statictextstruct *statictext;
statictext MakeStatic(int x, int y, char* str);
void FreeStatic(statictext s);

typedef struct {
   input i;
   statictext s;} inputandstatic;
inputandstatic MakeInputAndStatic(int,int,int,char*,char**);
void FreeInputAndStatic(inputandstatic);

int Keuze(int keuze, int escapeallowed, int aantal,...);
void colorline(int kleur, char*text,...);
void centercolorline(int kleur, char*text,...);
void printerror(char*text,...);
void headerline(char*text);

void FatalStatusLine(char*text);
void StatusLine(char* text);
void pressanykey();


void FreeStaticText(statictext);
void FreeKeuze(keuze);
void FreeInput(input);
void FreeListBox(listbox);
#endif
