#include "myio.h"
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>
#include "misc.h"

#define KEUZE_ID 0
#define INPUT_ID 1
#define STATIC_ID 2
#define LISTBOX_ID 3

#define DD_NEXT 0
#define DD_PREV 1
#define DD_OK 2
#define DD_CANCEL 3

struct DialogData {char id;};
struct listboxstruct  
     {
	struct DialogData d;  
	int x,y,dx,dy;   /* de window */
	char***contents;   /* de array van items */
	int breedte;    /* aantal fields in een item */
	int hoogte;     /* aantal items */
	char**header;   /* header */ 
	int current;    /* huidige selectie */
	int drawstart;  /* aantal lijnen overslaan bij listbox */
	int startx;     /* aantal karakters overslaan bij listboxline */
	void(*currentchanged)(void*record,void*common);   /* de callback als de huidige selectie wijzigt */
	void*commonforcc;
	void (*key)(int c,void*record,void*common);   /* de callback voor nen onbekenden toets */
	void*commonforkey;
     };


struct statictextstruct
     {
	struct DialogData d;
	int x,y;
	char* str;
     };

struct inputstruct
     {
	struct DialogData d;
	int x,y,aantal,curpos;
	char**str;
     };

struct keuzestruct 
     {
	struct DialogData d;
	int x,y; /* de positie op 't schermpje */
	int Current;
	int aantal;
	char **Keuzes;
     };

struct dialogstruct 
     {
	int aantal;
	int current;
	struct DialogData **Entrys;
     };


void SetListBoxContents(listbox lb,char***contents, int hoogte)
     {
	assert(lb);
	lb->contents=contents;
	lb->hoogte=hoogte;
	if (lb->current>=hoogte) lb->current=hoogte-1;
	if (lb->current<0) lb->current=0;
     }

int GetListBoxCurrent(listbox lb)
     {
	assert(lb);
	return lb->current;
     }

listbox MakeListBox(int x, int y, int dx, int dy,
		    char***contents, int breedte, int hoogte, char**Header)
     {
	listbox lb;
	lb=(listbox)zmalloc(sizeof(struct listboxstruct));
	lb->d.id=LISTBOX_ID;
	lb->x=x;
	lb->y=y;
	lb->dx=dx;
	lb->dy=dy;
	lb->contents=contents;
	lb->breedte=breedte;
	lb->hoogte=hoogte;
	lb->current=lb->drawstart=lb->startx=0;
	lb->header=Header;
	lb->key=lb->commonforkey=
	lb->currentchanged=lb->commonforcc=NULL;
	return lb;
     }

void SetListBoxCurrentChangedCallback(listbox lb,void(*callback)(void*record,void*common),void*common)
     {
	assert(lb);
	lb->currentchanged=callback;
	lb->commonforcc=common;
     }

void SetListBoxKeyCallback(listbox lb,void(*callback)(int c,void*record,void*common),void*common)
     {
	assert(lb);
	lb->key=callback;
	lb->commonforkey=common;
     }

statictext MakeStatic(int x, int y, char* str)
     {
	statictext s;
	s=(statictext)zmalloc(sizeof(struct statictextstruct));
	s->d.id=STATIC_ID;
	s->x=x;
	s->y=y;
	s->str=str;
	return s;
     }


void FreeStaticText(statictext s)
     {
	assert(s);
	free(s);
     };

void FreeListBox(listbox l)
     {
	assert(l);
	free(l);
     };

void FreeKeuze(keuze k)
{
   assert(k);
   free(k->Keuzes);
   free(k);
}

void FreeInput(input p)
{
   assert(p);
   free(p);
}


int GetKeuzeCurrent(keuze k)
     {assert(0);}

input MakeInput(int x, int y, int aantal, char** s)
{
   input i;
   i=(input)zmalloc(sizeof(struct inputstruct));
   i->d.id=INPUT_ID;
   i->x=x;
   i->y=y;
   i->aantal=aantal;
   i->curpos=0;
   i->str=s;
   return i;
}

void SetInputString(input i, char** str)     {assert(0);}
void PasteInputString(input i, char* str)     {assert(0);}
keuze MakeKeuze(int pos, int x, int y, int aantal,...)     {assert(0);}
void FreeDialog(dialog d) {assert(0);}
void FreeDialogAndContents(dialog d) {}
dialog MakeDialog(int aantal,char* Title,...) {assert(0);}
void SetDialogCurrent(dialog d, int i) {}
void RedrawDialog(dialog d) {}
int RunDialog(dialog d)                  {assert(0);}
void DrawInput(struct DialogData*dd)     {assert(0);}
int DoInput(struct DialogData *dd)       {assert(0);}
void DrawStaticText(struct DialogData* dd)     {assert(0);}
int DoStaticText(struct DialogData* dd)  {assert(0);}
void InitMyIo(void)   {}
void DoneMyIo(void)   {};
void DrawKeuze(struct DialogData* d)     {assert(0);}
void DrawListBox(struct DialogData* d)     {assert(0);}
int DoListBox(struct DialogData*dd)  {assert(0);}
int DoKeuze(struct DialogData*dd)     {assert(0);}
int Keuze(int keuze, int escapeallowed, int aantal,...) {assert(0);}
inputandstatic MakeInputAndStatic(int x,int y, int length, char* label,char**inputdata) {assert(0);}
void FreeInputAndStatic(inputandstatic w) {assert(0);}
void pressanykey() {assert(0);}
void StatusLine(char* text) {}
void FatalStatusLine(char* text) {printf("Fatal: %s",text); exit(1);}
